explain_readv_or_die(3)

NAME
explain_readv_or_die - read data into multiple buffers and report errors

SYNOPSIS
#include <libexplain/readv.h>

ssize_t explain_readv_or_die(int fildes, const struct iovec *iov, int iovcnt);
ssize_t explain_readv_on_error(int fildes, const struct iovec *iov, int iovcnt);

DESCRIPTION
The explain_readv_or_die function is used to call the readv(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_readv(3) function, and then the process terminates by calling exit(EXIT_FAILURE).

The explain_readv_on_error function is used to call the readv(2) system call. On failure an explanation will be printed to stderr, obtained from the explain_readv(3) function, but still returns to the caller.

fildes
    The fildes, exactly as to be passed to the readv(2) system call.

iov The iov, exactly as to be passed to the readv(2) system call.

iovcnt
    The iovcnt, exactly as to be passed to the readv(2) system call.

RETURN VALUE
The explain_readv_or_die function only returns on success, see readv(2) for more information. On failure, prints an explanation and exits, it does not return.

The explain_readv_on_error function always returns the value return by the wrapped readv(2) system call.

EXAMPLE
The explain_readv_or_die function is intended to be used in a fashion similar to the following example:
    ssize_t result = explain_readv_or_die(fildes, iov, iovcnt);

SEE ALSO

readv(2)
    read data into multiple buffers

explain_readv(3)
    explain readv(2) errors

exit(2)
    terminate the calling process

COPYRIGHT
libexplain version
Copyright (C) 2009 Peter Miller